/*
 * 
 * Copyright (C) 2004, 2005 Oliver Plohmann
 * All rights reserved.
 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that redistributions of source    
 * code or in binary form must reproduce the above copyright notice, 
 * and the disclaimer that follows.

 * In addition, you are required that you include in the  end-user 
 * documentation provided with the redistribution and/or in the 
 * software itself an acknowledgement equivalent to the following:
 * "This product is based on the Janet software developed by the 
 * JANET Project (http://www.almendra.org/janet)."

 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE JANET AUTHORS OR THE PROJECT
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

package org.almendra.commons.util.logging;

import java.awt.Toolkit;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;

/**
 * @author Oliver Plohmann
 *
 */
public class ErrorLogger
{
	protected static ErrorLogger Instance = null;
	
	 protected LogView view = null;
	
	/**
	 * Creates a new <code>ErrorLogger</code> object.
	 */
	public ErrorLogger()
	{
		super();
	}
	
	public static ErrorLogger getInstance()
	{
		if(Instance == null)
		{
			Instance = new ErrorLogger();
		}
		return Instance;
	}
	
	public void closed(LogView view)
	{
//		if(getInstance().view == view)
//			getInstance().view = null;
	}
	
	public static void exception(Throwable ex)
	{
		print(ex.toString());
	}
	
	public static void exception(String text)
	{
		try
		{
			fail(text);
		}
		catch (Exception e)
		{
			StringWriter out = new StringWriter();
			PrintWriter str = new PrintWriter(out);
			e.printStackTrace(str);
			print(e.getMessage() + out.getBuffer().toString());
			try
			{
				out.close();
			}
			catch (IOException e1)
			{
				System.out.println(e1.getMessage());
				e1.printStackTrace();
			}
			str.close();
		}
	}
	
	/**
	 * @param string
	 */
	protected static void print(String text)
	{
		getInstance().openView();
		Toolkit.getDefaultToolkit().beep();
		getInstance().view.getJTextPane().insert(text + "\n", 1); //$NON-NLS-1$
	}

	public static void fail(String text)
	throws Exception
	{
		throw new Exception(text);
	}

	/**
	 * 
	 */
	protected void openView()
	{
		if(getInstance().view == null)
		{
			getInstance().view = LogView.open("Excpetion occured"); //$NON-NLS-1$
			getInstance().view.getJTextPane().append("\n"); //$NON-NLS-1$
		}
	}
}
