/*
 * 
 * Copyright (C) 2004, 2005 Oliver Plohmann
 * All rights reserved.
 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that redistributions of source    
 * code or in binary form must reproduce the above copyright notice, 
 * and the disclaimer that follows.

 * In addition, you are required that you include in the  end-user 
 * documentation provided with the redistribution and/or in the 
 * software itself an acknowledgement equivalent to the following:
 * "This product is based on the Janet software developed by the 
 * JANET Project (http://www.almendra.org/janet)."

 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE JANET AUTHORS OR THE PROJECT
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

package org.almendra.janet.ade.observer.simulation.gui;

import java.awt.Dimension;
import java.awt.Point;
import java.util.Map;

import org.almendra.commons.events.ICallbackHandler;
import org.almendra.janet.ade.observer.simulation.ObserverAnchorSimulation;
import org.almendra.janet.cas.node.Node;
import org.almendra.janet.cas.node.gui.NodeViewsRegistry;


/**
 * @author Oliver Plohmann
 *
 */
public class OpenObserverSimulationHandler implements ICallbackHandler
{
	protected ObserverAnchorSimulation anchor = null;
	protected Node node = null;
	
	/**
	 * Creates a new <code>OpenObserverSimulationHandler</code> object.
	 */
	public OpenObserverSimulationHandler()
	{
		super();
	}

	/**
	  * Creates a new <code>OpenObserverSimulationHandler</code> object.
	  */
	public OpenObserverSimulationHandler(ObserverAnchorSimulation anchor, Node node)
	{
		super();
		this.anchor = anchor;
		this.node = node;
	}

	/* (non-Javadoc)
	 * @see org.almendra.commons.commons.events.ICallbackHandler#handle(java.lang.Object)
	 */
	public void handle(Object callbackParameter)
	{
		Map<String, Object> values = (Map<String, Object>) callbackParameter;
		Point location = (Point) values.get(NodeViewsRegistry.ViewLocation);
		Dimension dimension = (Dimension) values.get(NodeViewsRegistry.ViewSize);
		
		ObserverSimulationViewController controller = ObserverSimulationView.open(location, dimension);
		controller.setAnchor(anchor);
		controller.setNode(node);
	}
}
