/*
 * 
 * Copyright (C) 2004, 2005 Oliver Plohmann
 * All rights reserved.
 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that redistributions of source    
 * code or in binary form must reproduce the above copyright notice, 
 * and the disclaimer that follows.

 * In addition, you are required that you include in the  end-user 
 * documentation provided with the redistribution and/or in the 
 * software itself an acknowledgement equivalent to the following:
 * "This product is based on the Janet software developed by the 
 * JANET Project (http://www.almendra.org/janet/)."

 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE JANET AUTHORS OR THE PROJECT
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
package org.almendra.janet.cas.events;

import java.io.Serializable;
import java.util.List;

import org.almendra.commons.util.collection.IIdentifiableListEvaluator;

public class ClusterHandlerList extends AbstractHandlerList<ClusterEventHandlerEnvelope> implements Serializable, Iterable<ClusterEventHandlerEnvelope>, IIdentifiableListEvaluator<ClusterEventHandlerEnvelope>
{

	private static final long serialVersionUID = -9125057146307158719L;

	/**
	 * Creates a new <code>ClusterHandlerList</code> object.
	 */
	public ClusterHandlerList()
	{
		super();
	}
	
	/**
	 * Creates a new <code>HandlerList</code> object.
	 */
	public ClusterHandlerList(ClusterEventHandlerEnvelope item)
	{
		super();
		add(item);
	}
	
	public boolean add(ClusterEventHandlerEnvelope item)
	{
		return list.add(item);
	}

    /* (non-Javadoc)
     * @see org.almendra.commons.util.collection.IListEvaluator#get()
     */
    public List<ClusterEventHandlerEnvelope> get()
    {
        return list;
    }

}
